
macroScript PatternMaker

	category:             "PatternMaker"
    internalCategory:     "PatternMaker"
    buttonText:           "PatternMaker"
    icon:                 #("Systems",2)
    toolTip:             "Sets the scene up for pattern creation"
(
	global patternMakerTool
	
	rollout patternMakerRollout "Pattern Maker" width:164 height:700
	(
		spinner patternX "Width " pos:[24,104] width:88 height:16 enabled:true range:[0,100,10]
		spinner patternY "Height" pos:[24,76] width:88 height:16 enabled:true range:[0,100,10]
		button createTile "Create Tile" pos:[16,228] width:96 height:23 enabled:true 
 
 
		button makePattern "Preview Pattern" pos:[16,300] width:96 height:23 
 
 
		button delete "Delete Preview" pos:[16,332] width:96 height:23 
 
 
		button AttchObject "Attach Object" pos:[16,156] width:96 height:23
		button crtPattern "Bake Tile" pos:[16,372] width:96 height:38 enabled:true	
	
	
		button btn22 "Create Base" pos:[16,124] width:96 height:23 enabled:true 				
 				
 				
		button deleteTilePreview "Delete Tile" pos:[16,260] width:96 height:23 enabled:true
		button remRef "Remove ref plane" pos:[16,188] width:96 height:23
		label lbl1 "Paul Roberts 2011" pos:[16,420] width:96 height:24
		bitmap bmp1 "Bitmap" pos:[0,0] width:134 height:70 enabled:true fileName:"patMakLogo.jpg"
		
		on createTile pressed do
		(
			w = patternX.value
			l = patternY.value
		    createTiles w l
		
			)
		on makePattern pressed do
		(	
			w = patternX.value
			l = patternY.value
			createTileMatrix w l
		)
		on delete pressed do
		(
			deletePattern 0
			)
		on AttchObject pressed do
		(
			attachObject 0
		)
		on crtPattern pressed do
		(
			w = patternX.value
			l = patternY.value
			createFlattenedTile w l
			)
		on btn22 pressed do
		(
			w = patternX.value
			l = patternY.value
		    createBase w l
			--createTileMatrix
			)
		on deleteTilePreview pressed do
		(
			w = patternX.value
			l = patternY.value
		    deleteTile 0 
		
			)
		on remRef pressed do
		(
			removeGround 0
		)
	)

	try
	(
		closeRolloutFloater patternMakerTool
	) catch()


        patternMakerTool= NewRolloutFloater "pattern Maker" 150 480
        addRollout patternMakerRollout patternMakerTool
 	

		
)

function createTileMatrix W L  =

(	try (
	deselect $*
	for i = 1 to 3 do 
	(
		for v = 1 to 3 do
		(
			xCenter = W*3		
			yCenter = L*1.5
			maxops.cloneNodes $finTiles offset: [(xCenter-3*(W/2))+(V*W),(yCenter+(3*L/2))+(i*L)*-1,0] cloneType:#instance

	
		)
	) 
	) catch()
)

function createBase W L =
		(
			xCenter = -W/2	
			yCenter = L*1.5
			baseTile = Plane lengthsegs:1 widthsegs:1 length:L width:W pos:[0,0,0] isSelected:off name:"baseTile"
			convertTo baseTile Editable_Poly 
		)
		
function createTiles W L = 
(
		global workingTile = #(1,2,3,4,5,6,7,8,9)
		xCenter = -W/2	
		yCenter = L*1.5
		deselect $*
	--Create the Array
			for i = 1 to 3 do 
			(
				for v = 1 to 3 do
			(
					--multiplier 
					workingTile[i*v] = reference $baseTile
					print "test"
					workingTile[i*v].name = "FFS"
					workingTile[i*v].pos = [(xCenter-3*(w/2))+(v*W),(yCenter-3*(L/2))+(i*L)*-1,0]
			
						if (v==1) then multiplier=1 else if (v==2) then multiplier=0 else multiplier = -1
						if (i==1) then ymultiplier=-1 else if (i==2) then ymultiplier=0 else ymultiplier = 1
						
			addModifier workingTile[i*v] (sliceModifier name:"rightSlice" slice_type:2)
			workingTile[i*v].rightSlice.slice_plane.rotation = quat 0 1 0 1
			workingTile[i*v].rightSlice.slice_plane.position = [(W/2)+(W*multiplier), 0, 0]
			--LEft
			addModifier workingTile[i*v] (sliceModifier name:"leftSlice" slice_type:3)
			workingTile[i*v].leftSlice.slice_plane.rotation = quat 0 1 0 1
			workingTile[i*v].leftSlice.slice_plane.position = [(W/2*-1)+(W*multiplier), 0, 0]
			--bottom
			addModifier workingTile[i*v] (sliceModifier name:"bottomSlice" slice_type:3 )
			workingTile[i*v].bottomSlice.slice_plane.rotation = quat 1 0 0 1
			workingTile[i*v].bottomSlice.slice_plane.position = [0, (L/2)+(L*ymultiplier), 0]
			--top
			addModifier workingTile[i*v] (sliceModifier name:"topSlice" slice_type:2)
			workingTile[i*v].topSlice.slice_plane.rotation = quat 1 0 0 1
			workingTile[i*v].topSlice.slice_plane.position = [0, (L/2*-1)+(l*ymultiplier), 0]
		)
	)

		$*.wirecolor = color 180 180 180
		group $FFS* name:"finTiles"

	)
		  
function deletePattern nowt  =
		 (
	
		try ( delete $fintiles0*) catch ()
		 )
		 
function deleteTile nowt  =
		 (
	
		try ( delete $finTiles) catch ()
		 )
		 
function attachObject nowt = 
			 
		 (
			 objectNumber = 1
			 try(objectNumber = $.count) catch()
			 
			if (objectNumber > 1) do
(			 
			 for i = 1 to objectNumber do 
			 (
					try (polyop.attach $baseTile $[objectNumber-i]) catch()
				 )
			 )
				 try (polyop.attach$baseTile $) catch()
		 )
		 
function createFlattenedTile L W = 
	
(	
	deselect $*
	try(
	finalTile = Plane lengthsegs:1 widthsegs:1 length:L width:W pos:$finTiles.Position isSelected:on name:"finalTile"
	convertTo finalTile editable_Poly
	polyop.deleteFaces $finalTile  1 delIsoVerts:true
	
	for obj in $finTiles do

	(

		polyop.attach $finalTile obj 
	)
	
	finalTile.name = "FINISHED PATTERN"
)
catch()
)
	
function removeGround nowt = 
			 
		 (
			 try (polyop.deleteFaces $baseTile 1 delIsoVerts:true) catch()
		 )

	